Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/IPlushCreator.cs	(revision 15273)
@@ -0,0 +1,8 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator {
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
+
+  public interface IPlushCreator : ISolutionCreator, IPlushOperator {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionCreator.cs	(revision 15273)
@@ -0,0 +1,126 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator {
+  using System;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+
+  /// <summary>
+  /// Generates a new random integer vector with each element uniformly distributed in a specified range.
+  /// </summary>
+  [Item("PushSolutionCreator", "An operator which creates a new random int vector with each element uniformly distributed in a specified range and considering Push specific details")]
+  [StorableClass]
+  public class PushSolutionCreator : UniformRandomIntegerVectorCreator {
+
+    private const string ERC_OPTIONS_PARAMETER_NAME = "ERC options";
+    private const string MIN_LENGTH_PARAMETER_NAME = "Min. Length";
+    private const string MAX_LENGTH_PARAMETER_NAME = "Max. Length";
+    private const string IN_INSTRUCTION_PROBABILITY = "IN Instruction Probability";
+
+    public PushSolutionCreator() {
+      if (!Parameters.ContainsKey(ERC_OPTIONS_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<ErcOptions>(ERC_OPTIONS_PARAMETER_NAME));
+
+      if (!Parameters.ContainsKey(MIN_LENGTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(MIN_LENGTH_PARAMETER_NAME, new IntValue(20)));
+
+      //if (!Parameters.ContainsKey(MAX_LENGTH_PARAMETER_NAME))
+      //  Parameters.Add(new FixedValueParameter<IntValue>(MAX_LENGTH_PARAMETER_NAME, new IntValue(100)));
+
+      if (!Parameters.ContainsKey(IN_INSTRUCTION_PROBABILITY))
+        Parameters.Add(new FixedValueParameter<PercentValue>(IN_INSTRUCTION_PROBABILITY, new PercentValue(0.05)));
+    }
+
+    [StorableConstructor]
+    public PushSolutionCreator(bool deserializing) : base(deserializing) {
+    }
+
+    public PushSolutionCreator(PushSolutionCreator origin, Cloner cloner) : base(origin, cloner) { }
+
+
+    public IValueParameter<ErcOptions> ErcOptionsParameter
+    {
+      get { return (IValueParameter<ErcOptions>)Parameters[ERC_OPTIONS_PARAMETER_NAME]; }
+    }
+
+    public ErcOptions ErcOptions
+    {
+      get { return ErcOptionsParameter.Value; }
+      set
+      {
+        ErcOptionsParameter.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MinLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MIN_LENGTH_PARAMETER_NAME]; }
+    }
+
+    public int MinLength
+    {
+      get { return MinLengthParameter.Value.Value; }
+      set { MinLengthParameter.Value.Value = value; }
+    }
+
+    //public IValueParameter<IntValue> MaxLengthParameter
+    //{
+    //  get { return LengthParameter; } //(IValueParameter<IntValue>)Parameters[MAX_LENGTH_PARAMETER_NAME]; }
+    //}
+
+    //public int MaxLength
+    //{
+    //  get { return MaxLengthParameter.Value.Value; }
+    //  set { MaxLengthParameter.Value.Value = value; }
+    //}
+
+    public IValueParameter<PercentValue> InInstructionProbabilityParameter
+    {
+      get { return (IValueParameter<PercentValue>)Parameters[IN_INSTRUCTION_PROBABILITY]; }
+    }
+
+    public double InInstructionProbability
+    {
+      get { return InInstructionProbabilityParameter.Value.Value; }
+      set { InInstructionProbabilityParameter.Value.Value = value; }
+    }
+
+    protected override IntegerVector Create(IRandom random, IntValue length, IntMatrix bounds) {
+      var len = length.Value;
+      var result = new IntegerVector(len);
+
+      var variableLength = random.Next(MinLength, len);
+      var contentLength = Math.Min(variableLength, len);
+      var lowerBound = bounds[0, 0];
+      var upperBound = bounds[0, 1];
+      var inInstructionRelativeProbability = ErcOptions.ErcProbability + InInstructionProbability;
+
+      for (var i = 0; i < contentLength; i++) {
+        var x = random.NextDouble();
+
+        if (ErcOptions.ErcProbability > 0 &&
+            x <= ErcOptions.ErcProbability)
+          result[i] = PushSolutionEncoding.Erc;
+        else if (InInstructionProbability > 0 &&
+                 x <= inInstructionRelativeProbability)
+          result[i] = PushSolutionEncoding.In;
+        else
+          result[i] = random.Next(lowerBound, upperBound);
+      }
+
+      if (contentLength < len) {
+        result[contentLength] = PushSolutionEncoding.End;
+
+        for (var i = contentLength + 1; i < len; i++) {
+          result[i] = PushSolutionEncoding.Noop;
+        }
+      }
+
+      return result;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionEncoding.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionEncoding.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/SolutionCreator/PushSolutionEncoding.cs	(revision 15273)
@@ -0,0 +1,8 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator {
+  public class PushSolutionEncoding {
+    public const int Noop = -1;
+    public const int Erc = -2;
+    public const int In = -3;
+    public const int End = -4;
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15273)
@@ -15,5 +15,5 @@
 
   [View("Push Expression Selection Editor")]
-  [Content(typeof(IEnabledExpressionsConfiguration), true)]
+  [Content(typeof(IExpressionsConfiguration), true)]
   public partial class ExpressionSelectionView : ItemView {
     public ExpressionSelectionView() {
@@ -24,7 +24,7 @@
     }
 
-    public new IEnabledExpressionsConfiguration Content
+    public new IExpressionsConfiguration Content
     {
-      get { return (IEnabledExpressionsConfiguration)base.Content; }
+      get { return (IExpressionsConfiguration)base.Content; }
       set
       {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15273)
@@ -54,5 +54,6 @@
       }
 
-      interpreter = pool.Create(Content.Random);
+      var random = Content.GetRandom();
+      interpreter = pool.Create(random);
 
       InitDebugLists(Content.Config);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/SolutionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/SolutionTests.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/SolutionTests.cs	(revision 15273)
@@ -6,5 +6,4 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
@@ -35,5 +34,5 @@
 
       config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
-      data.InitInExpressions(config);
+      config.InitInExpressions(data.TotalInputArgumentCount);
 
       var evaluator = new PushBenchmarkSuiteEvaluator(data);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 15273)
@@ -313,5 +313,5 @@
 
         CheckOtherStacksAreEmpty();
-        interpreter.Clear();
+        interpreter.ClearStacks();
       }
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15273)
@@ -173,5 +173,5 @@
       Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
 
-      interpreter.Clear();
+      interpreter.ClearStacks();
       interpreter.IntegerStack.Push(1, 2);
       interpreter.FloatStack.Push(2.1, 0.7);
@@ -204,5 +204,5 @@
       Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
 
-      interpreter.Clear();
+      interpreter.ClearStacks();
       interpreter.IntegerStack.Push(1, 2);
       interpreter.FloatStack.Push(2.1, 0.7);
